package hviezdoslav.synonyms;

import java.util.ArrayList;

public class Entry {
  private ArrayList meanings = new ArrayList();
  private ArrayList variants = new ArrayList();
  private ArrayList links = new ArrayList();

  private String ident = "";
  private String name = "";

  /* -------------- constructors */
  public Entry(String name) {
    this.name = name;
  }

  public Entry() {
  }

  /* -------------- getters and setters */

  public ArrayList getMeanings() {
    return meanings;
  }

  public void setMeanings(ArrayList value) {
    meanings = value;
  }

  public ArrayList getVariants() {
    return variants;
  }

  public void setVariants(ArrayList value) {
    variants = value;
  }

  public ArrayList getLinks() {
    return links;
  }

  public void setLinks(ArrayList value) {
    links = value;
  }

  public String getIdent() {
    return ident;
  }

  public void setIdent(String value) {
    ident = value;
  }

  public String getName() {
    return name;
  }

  public void setName(String value) {
    name = value;
  }

  /* -------------- helper methods */
  public void addLink(Link link) {
    this.links.add(link);
  }

  public void addMeaning(Meaning m) {
    this.meanings.add(m);
  }

  public void addVariant(Variant v) {
    this.variants.add(v);
  }

  public String toString() {
    return this.name;
  }
}