package hviezdoslav.synonyms.xml;

import org.apache.commons.digester.Digester;
import hviezdoslav.synonyms.*;
import java.io.File;

public class ThezaurusDigester {
   public void digest(File f) {
      try {
         Digester digester = new Digester();
         digester.setValidating( false );
/*
Slovnik
  Slovnik/heslo
    Slovnik/heslo/clen
      Slovnik/heslo/clen/link
      Slovnik/heslo/clen/priklad
      Slovnik/heslo/clen/priklad/link
    Slovnik/heslo/vyznam
      Slovnik/heslo/vyznam/clen
        Slovnik/heslo/vyznam/clen/link
        Slovnik/heslo/vyznam/clen/priklad
        Slovnik/heslo/vyznam/clen/priklad/link
      Slovnik/heslo/vyznam/link
      Slovnik/heslo/vyznam/priklad
*/

         digester.addObjectCreate("Slovnik", Thezaurus.class);
           digester.addObjectCreate("Slovnik/heslo", Entry.class);
             digester.addObjectCreate("Slovnik/heslo/clen", Variant.class);
               digester.addObjectCreate("Slovnik/heslo/clen/link", Link.class);
               digester.addObjectCreate("Slovnik/heslo/clen/priklad", ExampleUsage.class);
                 digester.addObjectCreate("Slovnik/heslo/clen/priklad/link", ExampleUsage.class);
             digester.addObjectCreate("Slovnik/heslo/vyznam", Meaning.class);
               digester.addObjectCreate("Slovnik/heslo/vyznam/clen", Variant.class);
               digester.addObjectCreate("Slovnik/heslo/vyznam/clen/link", Link.class);
               digester.addObjectCreate("Slovnik/heslo/vyznam/clen/priklad", Variant.class);
                 digester.addObjectCreate("Slovnik/heslo/vyznam/clen/priklad/link", Link.class);
                 digester.addSetProperties("/Slovnik/heslo/vyznam/clen/priklad/link", "ciel", "target");
                 digester.addSetNext("/Slovnik/heslo/vyznam/clen/priklad/link", "addLink");

             digester.addObjectCreate("Slovnik/heslo/vyznam/link", Link.class);
             digester.addSetProperties("/Slovnik/heslo/vyznam/link", "ciel", "target");
             digester.addSetNext("/Slovnik/heslo/vyznam/link", "addLink");

             digester.addObjectCreate("Slovnik/heslo/vyznam/priklad", Link.class);

         Thezaurus t = (Thezaurus) digester.parse( f );

         //System.out.println( t.toString() );
         System.out.print("First entry:");
         for(int i = 0; i<t.getEntries().size(); i++) {
           Entry entry = (Entry) t.getEntries().get(i);
           System.out.println("E" + entry);
           for(int j = 0; j < entry.getMeanings().size(); j++) {
             System.out.println("  |" + ((Meaning)entry.getMeanings().get(j)).getName() + "|");
           }
         }

         //System.out.println(t.getEntries());

      } catch( Exception exc ) {
         exc.printStackTrace();
      }
   }

   public static void main(String[] args) {
     java.io.File input = new java.io.File("c:\\Projects\\hviezdoslav\\data\\synslov-s.xml");
     ThezaurusDigester d = new ThezaurusDigester();
     d.digest(input);
   }


}